-- Friends :)

-- Yes im naming the target friend victim
local function combifriend(player, victim)
	-- Initialize their combi variable stuff if we haven't already...
	combinator.initCombiPersVars(player)
	local cm = player.combiPersVars
	
	if not victim then
		CONS_Printf(player, "\x85What are you typing?")
		return
	end
	-- lowercase this thing
	victim = victim:lower()
	
	-- No friend?
	if victim == "none" then
		-- we have a pending friend? cancel it.
		if cm.friendpending > -1 and players[cm.friendpending] then
			local fren = players[cm.friendpending]
			local fcm = fren.combiPersVars
			fcm.friendpending = -1
			fcm.friend_num = -1
			S_StartSoundAtVolume(nil, sfx_itrole, 204, fren)
		end
		-- you are not my friends anymore
		cm.friendpending = -1
		cm.friend_num = -1
		S_StartSoundAtVolume(nil, sfx_itrole, 204, player)
		return
	end
	
	-- well? find player then
	local target = nil
	local node = tonumber(victim)
	
	-- by node number
	if node ~= nil and node >= 0 then
		if players[node] == player then
			-- you cant befriend yourself!
			CONS_Printf(player, "\x85You can't befriend yourself!")
			return
		end
		target = players[node]
	else
		-- assume we're looking by name.
		local results = {}
		for q in players.iterate do
			if string.find(q.name:lower(), victim, 0) then
				table.insert(results, q)
			end
		end
		
		if #results > 1 then
			-- there are other players with this name!
			CONS_Printf(player, "\x85There are other players with this name!")
			for i = 1, #results do
				CONS_Printf(player, results[i].name.." [Node "..#results[i].."]")
			end
			return
		elseif #results < 1 then
			-- there are no players with this name!
			CONS_Printf(player, "\x85The player you're looking for doesn't exist.")
			return
		end
		
		if results[1] == player then
			-- you cant befriend yourself!
			CONS_Printf(player, "\x85You can't befriend yourself!")
			return
		end
		
		target = results[1]
	end
	
	-- If by some miracle, STILL don't have anyone, just abort.
	if target == nil then return end
	
	-- generate combi vars!
	combinator.initCombiPersVars(target)
	local pcm = target.combiPersVars
	
	-- you ARE my friends anymore
	cm.friendpending = #target
	if target.bot then -- fuck off.
		pcm.friendpending = #player
	end
	
	local text = target.name.." will be your friend if they accept!"
	-- accepted friend request?
	if pcm.friendpending > -1 and pcm.friendpending == #player then
		text = target.name.." will always be your combi partner!"
		pcm.friend_num = pcm.friendpending
		S_StartSoundAtVolume(nil, sfx_slot05, 128, target)
	-- they already have a friend!
	elseif pcm.friendpending > -1 and pcm.friendpending ~= #player then
		text = target.name.." already has a friend!"
		cm.friendpending = -1
		return
	end
	
	CONS_Printf(player, text)
	
	-- From the partner's side...
	text = player.name.." wants to be friends! Type \"combi_friend " .. player.name .. "\" in the console to accept."
	if pcm.friendpending > -1 and pcm.friendpending == #player then
		text = player.name.." has accepted your friend request, and will always be your combi partner!"
		cm.friend_num = cm.friendpending
		S_StartSoundAtVolume(nil, sfx_slot05, 128, player)
	-- they already have a friend!
	elseif pcm.friendpending > -1 and pcm.friendpending ~= #player then
		text = player.name.." already has a friend!"
		pcm.friendpending = -1
		return
	end
	
	CONS_Printf(target, text)
end

COM_AddCommand("combi_friend", combifriend)

-- Clear ALL friend stuff when said friend leaves.
addHook("PlayerQuit", function(player)
	-- Initialize their combi variable stuff if we haven't already...
	combinator.initCombiPersVars(player)
	local cm = player.combiPersVars
	
	if cm.friendpending > -1 and players[cm.friendpending] then
		local free = players[cm.friendpending]
		local fcm = free.combiPersVars
		fcm.friendpending = -1
		fcm.friend_num = -1
		
		chatprintf(free, "\x84"..player.name.." has left and is longer your combi friend...", true)
	end
	
	cm.friendpending = -1
	cm.friend_num = -1
end)