---------------------------------------------------------------------------------------------------
--  __          ________ _      _____ ____  __  __ ______   _______ ____
--  \ \        / /  ____| |    / ____/ __ \|  \/  |  ____| |__   __/ __ \
--   \ \  /\  / /| |__  | |   | |   | |  | | \  / | |__       | | | |  | |
--    \ \/  \/ / |  __| | |   | |   | |  | | |\/| |  __|      | | | |  | |
--     \  /\  /  | |____| |___| |___| |__| | |  | | |____     | | | |__| |
--      \/  \/   |______|______\_____\____/|_|  |_|______|    |_|  \____/
--   _______ _    _ ______   _   _ ________   _________   _      ________      ________ _
--  |__   __| |  | |  ____| | \ | |  ____\ \ / /__   __| | |    |  ____\ \    / /  ____| |
--     | |  | |__| | |__    |  \| | |__   \ V /   | |    | |    | |__   \ \  / /| |__  | |
--     | |  |  __  |  __|   | . ` |  __|   > <    | |    | |    |  __|   \ \/ / |  __| | |
--     | |  | |  | | |____  | |\  | |____ / . \   | |    | |____| |____   \  /  | |____| |____
--     |_|  |_|  |_|______| |_| \_|______/_/ \_\  |_|    |______|______|   \/   |______|______|
--
---------------------------------------------------------------------------------------------------
-- Combi Ring is back! and worse than ever.
---------------------------------------------------------------------------------------------------

-- Initialize global namespace
rawset(_G, "combinator", {})
-- version stuff because im just fancy like that
combinator.versionMAJOR = 1
combinator.versionMINOR = 0
combinator.versionPATCH = 0
-- combinator.notes = "PublicTestBuild"
combinator.version = combinator.versionMAJOR.."."..combinator.versionMINOR.."."..combinator.versionPATCH
-- can be taken out at any time
if combinator.notes and combinator.notes ~= "" then
	combinator.version = $.."."..combinator.notes
end

local cvarprefix = "combi_"
local function addCvar(_name, _flags, _type, _defval, _cvarprefix, _desc, _func)
	_defval = $ or 0
	_cvarprefix = $ or cvarprefix
	if _func then _flags = $ | CV_CALL end
	_func = $ or function() end
	return CV_RegisterVar({
		name = _cvarprefix.._name,
		defaultvalue = _defval,
		flags = _flags | CV_SHOWMODIF,
		possiblevalue = _type,
		func = _func,
		description = _desc
	})
end

-------------------------------------
--  _____ _   _  ___  ______  _____
-- /  __ \ | | |/ _ \ | ___ \/  ___|
-- | /  \/ | | / /_\ \| |_/ /\ `--.
-- | |   | | | |  _  ||    /  `--. \
-- | \__/\ \_/ / | | || |\ \ /\__/ /
--  \____/\___/\_| |_/\_| \_|\____/
--
-------------------------------------

combinator.active = false -- actual thing that controls if its active based on map startup
combinator.enabled = addCvar("active", CV_NETVAR, CV_YesNo, "Yes", cvarprefix, "Hey, want some chaos?")
combinator.friendlyfire = addCvar("friendlyfire", CV_NETVAR, CV_YesNo, 0, cvarprefix, "Should offensive partner items hit the other player?")
-- combinator.allowfriends = addCvar("allowfriends", CV_NETVAR, CV_YesNo, 0, nil, "Hey, want some chaos?")
combinator.positiontag = addCvar("positiontag", CV_NETVAR, CV_YesNo, 0, cvarprefix, "Make position partner picking even raunchier. Achii's idea.") -- This was achii's idea blame him
combinator.teleportspoof = addCvar("teleportspoof", CV_NETVAR, CV_Natural, 1280, cvarprefix, "If a player is far enough away from their partner, teleport them to prevent getting stuck.")
combinator.flashbang = addCvar("flashbang", 0, CV_YesNo, "Yes", cvarprefix, "PAL_MIXUP moment. Set to no for no teleport spoof flashbang.")

-- SFC32 for minor local randomness to be used:tm:
local x, y, z, ctr = 1966444699, -108448308, -1945534430, 17

-- Returns 31 bits of random data as a positive integer.
local function rng_next()
    local b, c, counter = y, z, ctr
    local output = x + b + counter
    ctr = counter + 1
    x = b ^^ (b >> 9)
    y = c * 9
    z = output + ((c << 21) | (c >> 11))
    return output >> 1
end

-- Returns a random integer that will be positive.
function combinator.random(state)
    return rng_next(state) >> 1
end

-- Returns a random integer between 0 and FRACUNIT.
function combinator.randomFixed(state)
    return rng_next(state) >> 16
end

-- Only guaranteed to work properly with positive keys
-- Based on the JDK implementation
function combinator.randomKey(state, limit)
    if limit < 0 then error("limit can't be negative: "..tostring(n), 2)
    elseif limit < 2 then return 0
	end

	local rand, result
	local mod = limit-1
	repeat
		rand = rng_next(state) >> 1
		result = rand % limit
	until rand - result + mod >= 0

	return result
end

function combinator.randomRange(state, min, max)
    if max < min then error("max can't be less than min", 2)
    elseif max-min == -1 then return rng_next(state)
    end

    return min + combinator.randomKey(state, max-min + 1)
end

-- we cant keep mooching off MT_THOK forever....
freeslot("MT_COMBILINK")

mobjinfo[MT_COMBILINK] = {
	spawnstate = S_INVISIBLE,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_SCENERY|MF_DONTENCOREMAP
}

addHook("MobjThinker", function(mo)
	if not (mo.target and mo.target.valid) then P_RemoveMobj(mo) end
	if mo.tracer and mo.tracer.valid then
		mo.color = mo.tracer.color
	end
	local partner, gargoyle = combinator.returnPartnerMobj(mo.target.player, true)
	if partner == nil then P_RemoveMobj(mo) end
end, MT_COMBILINK)

-- COMBI RING DISTANCE STUFF
local CHAOTIXBANDLEN = 7
function combinator.drawCombiRing(mo, victim, force, gargoyle)
	-- taken from K_DrawDraftCombiring
	local n = CHAOTIXBANDLEN/2 -- Only draw one half as the other half is drawn by your partner.
	-- WELL except if you have a gargoyle. If it is, draw the full thing!
	if gargoyle then n = 6 end
	local fn = n
	
	local stepx = (victim.x - mo.x) / CHAOTIXBANDLEN
	local stepy = (victim.y - mo.y) / CHAOTIXBANDLEN
	local stepz = ((victim.z + (victim.height / 2)) - (mo.z + (mo.height / 2))) / CHAOTIXBANDLEN
	
	local curx, cury, curz = mo.x + stepx, mo.y + stepy, mo.z + stepz
	
	mo.combiBands = $ or {}
	
	-- force remove all of them
	if force then
		for _, k in ipairs(mo.combiBands) do
			if k and k.valid then
				P_RemoveMobj(k)
			end
		end
		mo.combiBands = {}
	end
	
	while (n) do
		-- spawn if the bands dont exist yet
		if (not (mo.combiBands[n-1] and mo.combiBands[n-1].valid)) then
			local zoffs = 4*FRACUNIT
			local band = P_SpawnMobj(curx, cury, curz + zoffs, MT_COMBILINK)
			band.scale = 3*mapobjectscale/2 -- 1.5x
			band.spriteyoffset = zoffs
			if n == fn or (gargoyle and n == 1) then
				band.sprite = SPR_BSPH
				band.frame = C
				band.scale = 3*mapobjectscale/4 -- 0.75x
			else
				band.state = S_SIGNSPARK1
				band.combiSparkle = true
				band.spriteyoffset = 6*FRACUNIT
			end
			band.frame = ($ & ~FF_TRANS50) | FF_SEMIBRIGHT
			band.color = (gargoyle and mo.color or victim.color)
			band.colorized = true
			band.target = mo
			band.tracer = victim
			mo.combiBands[n-1] = band
		else -- exists, so just move them
			local band = mo.combiBands[n-1]
			P_MoveOrigin(band, curx, cury, curz)
			band.frame = ($ & ~FF_TRANS50) | FF_SEMIBRIGHT
			band.tracer = victim
		end
		
		curx = $ + stepx
		cury = $ + stepy
		curz = $ + stepz
		
		n = $ - 1
	end
end

-- https://github.com/GenericHeroGuy/ringracers-scripts/blob/master/src/sglua/Lua/Utils/libsg2.lua
-- returns viewx, viewy, viewz, viewangle, aimingangle, viewroll
local cv_tilting
rawset(_G, "SG_GetViewVars", function(v, p, c)
	if not cv_tilting then cv_tilting = CV_FindVar("tilting") end
	local roll = p.viewrollangle + (cv_tilting.value and not (p.spectator --[[or c.freecam]]) and p.tilt or 0)

	if p.awayviewtics then
		local mo = p.awayviewmobj
		return mo.x, mo.y, mo.z, mo.angle, mo.pitch, roll
	elseif c.chase then
		return c.x, c.y, c.z + c.height/2, c.angle, c.aiming, roll
	elseif p.mo then
		return p.mo.x, p.mo.y, p.viewz, p.mo.angle, p.aiming, roll
	end
end)

local fovvars
rawset(_G, "R_FOV", function(num)
	if not fovvars then
		fovvars = { [0] = CV_FindVar("fov"), CV_FindVar("fov2"), CV_FindVar("fov3"), CV_FindVar("fov4") }
	end
	return fovvars[num].value
end)

// This version of the function was prototyped in Lua by Nev3r ... a HUGE thank you goes out to them!
-- if only it was exposed
local baseFov = 90*FRACUNIT
local BASEVIDWIDTH = 320
local BASEVIDHEIGHT = 200

local views = nil

-- The most dumbest function to exist! Behold!
rawset(_G, "SG_GetSplitscreen", function()
	-- splitscreen returns the AMOUNT of splitscreen players...
	-- which does not change on replay viewing
	
	-- HEP2 has this exposed
	if r_splitscreen ~= nil then return r_splitscreen end
	-- local splitscreen has no problem
	if splitscreen > 0 then return splitscreen end
	
	-- i do not see it
	return 0
end)

rawset(_G, "SG_ObjectTracking", function(v, p, c, point, reverse)
	local cameraNum = c.pnum - 1
	local viewx, viewy, viewz, viewangle, aimingangle, viewroll = SG_GetViewVars(v, p, c)

	// Initialize defaults
	local result = {
		x = 0,
		y = 0,
		scale = FRACUNIT,
		onScreen = false
	}

	// Take the view's properties as necessary.
	local viewpointAngle, viewpointAiming, viewpointRoll
	if reverse then
		viewpointAngle = viewangle + ANGLE_180
		viewpointAiming = InvAngle(aimingangle)
		viewpointRoll = viewroll
	else
		viewpointAngle = viewangle
		viewpointAiming = aimingangle
		viewpointRoll = InvAngle(viewroll)
	end

	// Calculate screen size adjustments.
	local screenWidth = v.width()/v.dupx()
	local screenHeight = v.height()/v.dupy()

	-- what's the difference between this and r_splitscreen?
	-- future G: seems to alternate between view count and view number depending on where you are in the codebase
	-- may i interest the Krew in stplyrnum? :^)
	-- H: splitscreen doesnt fucking account for replay splitscreen. ok
	local r_splitscreen = SG_GetSplitscreen()
	
	if r_splitscreen >= 2 then
		// Half-wide screens
		screenWidth = $ >> 1
	end

	if r_splitscreen >= 1 then
		// Half-tall screens
		screenHeight = $ >> 1
	end

	local screenHalfW = (screenWidth >> 1) << FRACBITS
	local screenHalfH = (screenHeight >> 1) << FRACBITS

	// Calculate FOV adjustments.
	local fovDiff = R_FOV(cameraNum) - baseFov
	local fov = ((baseFov - fovDiff) / 2) - (p.fovadd / 2)
	local fovTangent = tan(FixedAngle(fov))

	if r_splitscreen == 1 then
		// Splitscreen FOV is adjusted to maintain expected vertical view
		fovTangent = 10*fovTangent/17
	end

	local fg = (screenWidth >> 1) * fovTangent

	// Determine viewpoint factors.
	local h = R_PointToDist2(point.x, point.y, viewx, viewy)
	local da = viewpointAngle - R_PointToAngle2(viewx, viewy, point.x, point.y)
	local dp = viewpointAiming - R_PointToAngle2(0, 0, h, viewz)

	if reverse then da = -da end

	// Set results relative to top left!
	result.x = FixedMul(tan(da), fg)
	result.y = FixedMul((tan(viewpointAiming) - FixedDiv((point.z - viewz), 1 + FixedMul(cos(da), h))), fg)

	result.angle = da
	result.pitch = dp
	result.fov = fg

	// Rotate for screen roll...
	if viewpointRoll then
		local tempx = result.x
		result.x = FixedMul(cos(viewpointRoll), tempx) - FixedMul(sin(viewpointRoll), result.y)
		result.y = FixedMul(sin(viewpointRoll), tempx) + FixedMul(cos(viewpointRoll), result.y)
	end

	// Flipped screen?
	if encoremode then result.x = -result.x end

	// Center results.
	result.x = $ + screenHalfW
	result.y = $ + screenHalfH

	result.scale = FixedDiv(screenHalfW, h+1)

	result.onScreen = not ((abs(da) > ANG60) or (abs(viewpointAiming - R_PointToAngle2(0, 0, h, (viewz - point.z))) > ANGLE_45))

	// Cheap dirty hacks for some split-screen related cases
	if result.x < 0 or result.x > (screenWidth << FRACBITS) then
		result.onScreen = false
	end

	if result.y < 0 or result.y > (screenHeight << FRACBITS) then
		result.onScreen = false
	end

	// adjust to non-green-resolution screen coordinates
	result.x = $ - ((v.width()/v.dupx()) - BASEVIDWIDTH)<<(FRACBITS-(splitscreen >= 2 and 2 or 1))
	result.y = $ - ((v.height()/v.dupy()) - BASEVIDHEIGHT)<<(FRACBITS-(splitscreen >= 1 and 2 or 1))
	return result
end)

-- set some splitscreen video flags
-- input: splitscreen index
-- returns: video flags
rawset(_G, "SG_GetSplitscreenFlags", function(splitindex)
	local r_splitscreen = SG_GetSplitscreen()
	if r_splitscreen == 1 then -- 2P
		return splitindex and V_SPLITSCREEN | V_SNAPTOBOTTOM
	elseif r_splitscreen >= 2 then -- 3P or 4P
		if splitindex == 1 then
			return V_SNAPTORIGHT | V_SNAPTOTOP
		elseif splitindex == 2 then
			return V_SNAPTOLEFT | V_SPLITSCREEN | V_SNAPTOBOTTOM
		elseif splitindex == 3 then
			return V_SNAPTORIGHT | V_SPLITSCREEN | V_SNAPTOBOTTOM
		end
	end
	return V_SNAPTOTOP
end)

rawset(_G, "SG_GetSplitscreenOffsets", function(v, splitindex)
	local x, y = 0, 0
	local r_splitscreen = SG_GetSplitscreen()
	
	-- YEAAAHH
	local screenWidth, screenHeight = v.width(), v.height()
	local screenScaleX, _frac = v.dupx()
	local screenScaleY, _frac = v.dupy()
	local gameWidth, gameHeight = screenWidth / screenScaleX, screenHeight / screenScaleY
	
	if (r_splitscreen > 1 and (splitindex & 1)) then
		x = (gameWidth/2) * FRACUNIT
	end
	if (r_splitscreen == 1 and (splitindex == 1)) or (r_splitscreen > 1 and (splitindex > 1)) then
		y = (gameHeight/2) * FRACUNIT
	end
	return x, y
end)

-- shill
print("\x86".."-----------------------------------------------------------")
print("\x89".."THE COMBINATOR - ".."\x85".."v"..combinator.version)
print("\x83".."WELCOME TO THE NEXT LEVEL.")
print("")
print("\x82".."Please contact merlinsotrue on Discord about bugs/problems.")
print("\x86".."-----------------------------------------------------------")